define [
  'jquery',
  '<%= javascript_path("templates/apps/app_stat_modal_header") %>'
], ($, Template) ->
  PUSH_VALIDATION_URL = "/workspaces/#{WORKSPACE_ID}/nexpose/result/push_validations.json"
  VALIDATION_POLL_INTERVAL = 500

  class AppStatModalHeader extends Backbone.Marionette.ItemView
    initialize: ({ @appRun }) =>
      @appRun.bind('change', @render)

    events:
      'click .push_validations': 'pushValidationsClicked'

    template: HandlebarsTemplates['apps/app_stat_modal_header']

    serializeData: =>
      _.extend({}, @, { stats: @appRun.runStatHash() })

    # called when user clicks the Push Validations button
    pushValidationsClicked: (e) =>
      $link = $(e.currentTarget).find('a')
      return if $link.is('.disabled')
      $link.addClass('disabled submitting')
      $.ajax
        url: PUSH_VALIDATION_URL
        type: 'GET' #TODO: CHANGE TO POST
        dataType: 'json'
        data: { run_id: @appRun.get('auto_exploitation_run_id') }
        success: (json) =>
          @startPollingValidationRun(json.task_id)
        error: (ohnoes) =>
          $link.removeClass('disabled submitting')

    # called when ValidationPush task is fired. we poll a status endpoint until
    # Task finishes or errors out.
    startPollingValidationRun: (taskId) =>
      done = false
      url = "/workspaces/#{WORKSPACE_ID}/tasks/#{taskId}.json"
      poll = =>
        $.ajax
          url: url
          success: (taskJson) =>
            if taskJson.completed_at?
              done = true
              if taskJson.error? and taskJson.error.length > 0
                img = '<img src="/assets/icons/incomplete.png" style="vertical-align: top;" />'
                $failed = $('<span />')
                $failed.css(paddingRight: '10px', verticalAlign: 'top')
                $failed.html(
                  img+" Push failed. [<a style='vertical-align:top;' href='/workspaces/#{WORKSPACE_ID}/tasks/#{taskId}'>more...</a>]"
                )
                $('span.push_validations', @el).replaceWith($failed)
              else
                img = '<img src="/assets/icons/complete.png" style="vertical-align: top" />'
                $succeeded = $('<span />')
                $succeeded.css(paddingRight: '10px', verticalAlign: 'top')
                $succeeded.html("#{img} Push succeeded.")
                $('span.push_validations', @el).replaceWith($succeeded)
            else
              setTimeout(poll, VALIDATION_POLL_INTERVAL) unless done
          error: =>
            done = true
            $('span.push_validations a', @el).removeClass('disabled submitting')

      setTimeout(poll, VALIDATION_POLL_INTERVAL)
